local dewdrop = DewdropLib:GetInstance('1.0')
local tablet = TabletLib:GetInstance('1.0')
local metro = Metrognome:GetInstance("1")

FuXP = FuBarPlugin:GetInstance("1.2"):new({
	name          = "FuXP",
	description   = "Lightweight XPBar tied to the FuBar",
	version       = "1.0",
	releaseDate   = "21-06-2006",
	aceCompatible = 103,
	author        = "Wobin",
	email         = "wobster@gmail.com",
	website       = "http://wobin.wowinterface.com/",
	category      = "bars", 
	defaults      = {
		ShowRemaining = false,
		Thickness = 2,
		XP = {0, 0.4,.9,1},
		Rest = {1, 0.2, 1, 1},
		None = {0.3,0.3,0.3,1},
	},
	db           = AceDatabase:new("FuXPDB"),
	hasIcon       = true,
	showOnRight   = false,
	cannotHideText	 = false,
	cannotAttachToMinimap = true,
	hideWithoutStandby = true,
})

function FuXP:Initialize()
	local XPBar = CreateFrame("Frame", "FuXPBar", UIParent)
	local tex = XPBar:CreateTexture("XPBarTex")
	XPBar:SetFrameStrata("HIGH")
	tex:SetTexture("Interface\\AddOns\\FuBar_FuXPFu\\Textures\\texture.tga")
	tex:SetVertexColor(self.data.XP[1], self.data.XP[2], self.data.XP[3], self.data.XP[4])
	tex:ClearAllPoints()
	tex:SetAllPoints(XPBar)
	tex:Show()
	XPBar:SetHeight(self.data.Thickness)
	
	local spark = XPBar:CreateTexture("XPSpark", "OVERLAY")
	spark:SetTexture("Interface\\AddOns\\FuBar_FuXPFu\\Textures\\glow.tga")
	spark:SetWidth(128)
	spark:SetHeight((self.data.Thickness) * 2.5)
	--spark:SetVertexColor(self.data.XP[1], self.data.XP[2], self.data.XP[3],1)
	spark:SetVertexColor(self.data.XP[1] + 0.5, self.data.XP[2] + 0.5, self.data.XP[3] + 0.5, 1)
	spark:SetBlendMode("ADD")

	local RestedXP = CreateFrame("Frame", "FuRestXPBar", UIParent)
	local restex = RestedXP:CreateTexture("RestedXPTex")
	restex:SetTexture("Interface\\AddOns\\FuBar_FuXPFu\\Textures\\texture.tga")
	restex:SetVertexColor(self.data.Rest[1], self.data.Rest[2], self.data.Rest[3], self.data.Rest[4])
	restex:ClearAllPoints()
	restex:Show()
	restex:SetAllPoints(RestedXP)
	RestedXP:SetHeight(self.data.Thickness)

	local NoXP = CreateFrame("Frame", "FuNoXPBar", UIParent)
	local notex = NoXP:CreateTexture("NoXPTex")
	notex:SetTexture("Interface\\AddOns\\FuBar_FuXPFu\\Textures\\texture.tga")
	notex:SetVertexColor(self.data.None[1], self.data.None[2], self.data.None[3], self.data.None[4])
	notex:ClearAllPoints()
	notex:Show()
	notex:SetAllPoints(NoXP)
	NoXP:SetHeight(self.data.Thickness)

	local Border = CreateFrame("Frame", "BottomBorder", UIParent)
	local bordtex = Border:CreateTexture("BottomBorderTex")
	bordtex:SetTexture("Interface\\AddOns\\FuBar_FuXPFu\\Textures\\border.tga")
	bordtex:SetVertexColor(0, 0, 0, 0.7)
	bordtex:ClearAllPoints()
	bordtex:Show()
	bordtex:SetAllPoints(Border)
	Border:SetHeight(8)

	self.XPBar = XPBar
	self.XPBarTex = tex
	self.Spark = spark
	self.NoXP = NoXP
	self.NoXPTex = notex
	self.RestedXP = RestedXP
	self.RestedXPTex = restex
	self.Border = Border
	self.BorderTex = bordtex
	self.Spark:SetParent(self.XPBar)
	self.RestedXP:SetParent(self.XPBar)
	self.NoXP:SetParent(self.XPBar)
	self.Border:SetParent(self.XPBar)
end

function FuXP:Enable()
	self:RegisterEvent("UPDATE_EXHAUSTION", "UpdateBars")
	self:RegisterEvent("PLAYER_XP_UPDATE", "UpdateBars")
	self:RegisterEvent("UPDATE_FACTION", "UpdateBars")
	self:RegisterEvent("FUBAR_CHANGED_PANELS")
	metro:Register("XPFuBar", self.Reanchor, 3, self)
	metro:Start("XPFuBar" )
	metro:Register(self.name, self.Update, 1, self)
	metro:Start(self.name)
	MainMenuExpBar:Hide()
	ReputationWatchBar:Hide()
	ExhaustionTick:Hide()
end

function FuXP:Disable()
	-- you do not need to unregister the event here, all events/hooks are unregistered on disable implicitly.
	self:HideBar()	
	MainMenuExpBar:Show()
	ReputationWatchBar:Show()
	ExhaustionTick:Show()
end

function FuXP:FUBAR_FINISHED_LOADING()
	self:debug("Fubar complete")
	metro:Start("XPFuBar",1)
end

function FuXP:FUBAR_CHANGED_PANELS()
	if(self.Loaded) then
		self:Reanchor()
	end
end

function FuXP:Reanchor()
	local point, relpoint, y
	
	if(self.panel) then 
		metro:Stop("XPFuBar") 
	else 
		return 
	end

	self.Loaded = true
	self.Panel = self.panel
	
	if(self.Panel:GetAttachPoint() == "BOTTOM") then
		self.Side = "BOTTOM"
		self.FuPanel = FuBar:GetTopmostBottomPanel()
		point = "BOTTOMLEFT"
		relpoint = "TOPLEFT"
	else
		self.Side = "TOP"
		self.FuPanel = FuBar:GetBottommostTopPanel()
		point = "TOPLEFT"
		relpoint = "BOTTOMLEFT"
	end
	self.XPBar:ClearAllPoints()
	self.Spark:ClearAllPoints()
	self.RestedXP:ClearAllPoints()
	self.NoXP:ClearAllPoints()
	self.XPBar:SetParent(self.FuPanel.frame)
	self.XPBar:SetPoint(point, self.FuPanel.frame, relpoint, 0, y or 0)
	self.Spark:SetPoint("RIGHT", self.XPBar, "RIGHT",7,0 )
	self.RestedXP:SetPoint("LEFT", self.XPBar, "RIGHT")
	self.NoXP:SetPoint("LEFT", self.RestedXP, "RIGHT")
	self.Border:SetPoint("TOPLEFT", self.XPBar, "BOTTOMLEFT")
	self:ShowBar()
	self:UpdateBars()
end

function FuXP:ShowBar()
	self.XPBar:Show()
	self.Spark:Show()
	self.RestedXP:Show()
	self.NoXP:Show()
	self.Border:Show()
end

function FuXP:HideBar()
	self.XPBar:Hide()
	self.Spark:Hide()
	self.RestedXP:Hide()
	self.NoXP:Hide()
end

function FuXP:SetThickness(thickness)
	self.XPBar:SetHeight(thickness)
	self.Spark:SetHeight((thickness) * 2.5)
	self.RestedXP:SetHeight(thickness)
	self.NoXP:SetHeight(thickness)
	self.data.Thickness = thickness
end



function FuXP:MenuSettings(level, value)
			dewdrop:AddLine(
				'text', 'Current XP',
				'hasColorSwatch', true, 
				'cancelFunc', function(r,g,b) self.XPBarTex:SetVertexColor(r,g,b) end,
				'r', self.data.XP[1],
				'g', self.data.XP[2],
				'b', self.data.XP[3],
				'swatchFunc',	function(r,g,b) 
									self.XPBarTex:SetVertexColor(r, g, b, 1)
									self.Spark:SetVertexColor(r + 0.5, g + 0.5, b + 0.5, 1)
									self.data.XP = { r, g, b, 1}
								end
			)
			dewdrop:AddLine(
				'text', 'Rested XP',

				'hasColorSwatch', true, 
				'cancelFunc', function(r,g,b) self.RestedXPTex:SetVertexColor(r,g,b) end,
				'r', self.data.Rest[1],
				'g', self.data.Rest[2],
				'b', self.data.Rest[3],
				'swatchFunc',	function(r,g,b) 
									self.RestedXPTex:SetVertexColor(r, g, b, 1)
									self.data.Rest = { r, g, b, 1}
								end
			)
			dewdrop:AddLine(
				'text', 'No XP',
				'hasColorSwatch', true, 
				'cancelFunc', function(r,g,b) self.NoXPTex:SetVertexColor(r,g,b) end,
				'r', self.data.None[1],
				'g', self.data.None[2],
				'b', self.data.None[3],
				'swatchFunc',	function(r,g,b) 
									self.NoXPTex:SetVertexColor(r, g, b, 1)
									self.data.None = { r, g, b, 1}
								end
			)
			dewdrop:AddLine(
				'text', 'Thickness',
				'hasArrow', true,
				'hasSlider', true,
				'sliderTop', 8,
				'sliderBottom', 1.5,
				'sliderValue', (self.data.Thickness - 1.5) / 6.5,
				'sliderFunc', function(value)
								self:SetThickness((value * 6.5) + 1.5)
								return string.format("%1.1f",(value * 6.5) + 1.5)
							end
			)
			dewdrop:AddLine(
				'text', 'Show Remaining in Bar',
				'checked', self.data.ShowRemaining,
				'func', function() self.data.ShowRemaining = not self.data.ShowRemaining end
			)
end

function FuXP:UpdateBars()
	if(not self.Loaded) then return end
	
	local name, standing, minRep, maxRep, currentRep = GetWatchedFactionInfo()
	local total = self.Panel.frame:GetWidth()

	self.Border:SetWidth(total)
	self.XPBar:SetWidth(0.001)
	self.RestedXP:SetWidth(0.001)
	self.NoXP:SetWidth(0.001)

	if(not name) then
		if(UnitLevel("player") == 60) then
			self.NoXP:SetWidth(total)
			return
		end
		local currentXP = UnitXP("player")
		local maxXP = UnitXPMax("player")
		local restXP = GetXPExhaustion() or 0
		local remainXP = maxXP - (currentXP + restXP)
		
		if(remainXP <= 0) then remainXP = 0 end

		self.XPBar:SetWidth((currentXP/maxXP)*total)
		if(((restXP + currentXP)/maxXP) > 1) then
			self.RestedXP:SetWidth(total - self.XPBar:GetWidth())
		else
			self.RestedXP:SetWidth((restXP/maxXP)*total + 0.001)
		end
		self.NoXP:SetWidth((remainXP/maxXP)*total)
	else
		self.XPBar:SetWidth(((currentRep - minRep)/(maxRep-minRep))*total)
		self.RestedXP:SetWidth(0.0001)
		self.NoXP:SetWidth(((maxRep - currentRep)/(maxRep - minRep))*total)
	end
end

function FuXP:UpdateText()
	if(not self.Loaded) then return end
	if(GetWatchedFactionInfo()) then
		local name, standing, minRep, maxRep, currentRep = GetWatchedFactionInfo()
		if(self.Type == "XP") then
			self:UpdateBars()
		end
		if(self.data.ShowRemaining) then
			self:SetText(string.format("%s", maxRep - currentRep ))
		else
			self:SetText("FuRepFu")
		end
		self.Type = "Rep"
	else
		if(self.Type == "Rep") then
			self:UpdateBars()
		end
		if(self.data.ShowRemaining) then
			self:SetText(string.format("%s", UnitXPMax("player") - UnitXP("player")))
		else
			self:SetText("FuXPFu")
		end
		self.Type = "XP"
	end
end

function FuXP:UpdateTooltip()
	if(not self.Loaded) then return end

	local totalXP = UnitXPMax("player")
	local currentXP = UnitXP("player")
	local toLevelXP = totalXP - currentXP
	local xp = tablet:AddCategory('columns', 2)
	local name, standing, minRep, maxRep, currentRep = GetWatchedFactionInfo()
	
	self:UpdateBars()
	
	if(self.panel:GetAttachPoint() ~= self.Side) then
		self:Reanchor()
	end

	if(not name) then
		xp:AddLine(
			'text', "Current XP",
			'text2', string.format("%s/%s (%3.0f%%)", currentXP,totalXP, (currentXP/totalXP)*100)
		)
		xp:AddLine(
			'text', "To Level",
			'text2', toLevelXP
		)
		if(GetXPExhaustion()) then
				xp:AddLine(
				'text', "Rested XP",
				'text2', GetXPExhaustion()
			)
		end
		tablet:SetHint("Click to send your current xp to an open editbox.")
	else
		xp:AddLine(
			'text', "Faction",
			'text2', name
		)
		xp:AddLine(
			'text', "Rep to next standing",
			'text2', maxRep - currentRep
		)
		xp:AddLine(
			'text', "Current rep",
			'text2', getglobal("FACTION_STANDING_LABEL"..standing)
		)
		tablet:SetHint("Click to send your current rep to an open editbox.")
	end
end

function FuXP:OnClick()
	local totalXP = UnitXPMax("player")
	local currentXP = UnitXP("player")
	local toLevelXP = totalXP - currentXP
	local name, standing, minRep, maxRep, currentRep = GetWatchedFactionInfo()
	
	if(not name) then
		DEFAULT_CHAT_FRAME.editBox:SetText(string.format("%s/%s (%3.0f%%) %d to go", currentXP,totalXP, (currentXP/totalXP)*100, totalXP - currentXP))
	else
		DEFAULT_CHAT_FRAME.editBox:SetText(string.format("%s/%s (%3.2f%%) Currently %s with %d to go", 
					currentRep - minRep,
					maxRep - minRep, 
					(currentRep-minRep)/(maxRep-minRep)*100,
					getglobal("FACTION_STANDING_LABEL"..standing),
					maxRep - currentRep))
	end
end

FuXP:RegisterForLoad()